	/*
	 File: wysuwyg_dragboard.js
	 Copyright: Rahul Singh
	 Mail: induscrypt@gmail.com
	 Source: http://wysuwyg.mozdev.org
	 Referenced by: wysuwyg_dragdrop.xul
	 Description: A window with DND capabilities, to be opened in the sidebar
	 			Uses a separate 'board' objects for each format	
	
	*/
	
	var os= Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;
	var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                        .getService(Components.interfaces.nsIXULAppInfo);
	var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                               .getService(Components.interfaces.nsIVersionComparator);
	var isFF35=(versionChecker.compare(appInfo.version, "3.5") >= 0);

	var isWin= (/^Win/i).test(os);
	 	
	 var boardObserver = { 
	 		getSupportedFlavours : function () 
	 		{
	 			var flavours = new FlavourSet();
	 			//flavours.appendFlavour("text/html");
	 			flavours.appendFlavour("text/x-moz-url");
	 			flavours.appendFlavour("text/unicode");	 			
	 			return flavours;
	 		},
	 		
	 		onDragOver: function (evt,flavour,session)
	 		{ //do nothing
	 		},
	 		
	 		
	 		onDrop: function (evt,dropdata,session)
	 		{
				
	 			if (dropdata.data!="")
	 			{
	 		   var dragSession=session;
	 		   //alert(dropdata.data + "\n content type= "+ dropdata.flavour.contentType);
	 		  
	 		  
	 			var elem=document.createElement("textbox"); 
	 			evt.target.appendChild(elem);
	 			
	 			elem.setAttribute("multiline",true); 			
	 			elem.setAttribute("value",dropdata.data);
	 			elem.setAttribute("onfocus","select()"); 
	 			
	
		
	 			}
	 		},
	 		
	 	
	 };
	 
	 
	  var htmlObserver = { 
	 		getSupportedFlavours : function () 
	 		{
	 			var flavours = new FlavourSet(); 	
	 			flavours.appendFlavour("text/html"); 			 			
	 			return flavours;
	 		},
	 		
	 		onDragOver: function (evt,flavour,session)
	 		{ //do nothing
	 		},
	 		
	 		
	 		onDrop: function (evt,dropdata,session)
	 		{
	 			if (dropdata.data!="")
	 			{
	 		   var dragSession=session;
	 		   //alert(dropdata.data + "\n content type= "+ dropdata.flavour.contentType);
	 		  
	 			var elem=document.createElement("textbox"); 
	 			evt.target.appendChild(elem);
	 			
	 			elem.setAttribute("multiline",true); 			
	 			elem.setAttribute("value",dropdata.data);
	 			elem.setAttribute("onfocus","select()"); //whoa :-) 			
	 			}
	 		},
	 		
	 	
	 };
	 
	 /* **************************************************************** */
	 /*Dec-Jan-March:  Changing it so that it creates image stuff from dropped HTML, 
			 as it was still not getting images flavour on Linux. 
	 */
	 
	  var imgDNDObserver = {
	  
	       
	 		getSupportedFlavours : function () 
	 		{
	 			var flavours = new FlavourSet();
	 			if (isWin)
	 			{
	 				flavours.appendFlavour("image/png"); 			
	 				flavours.appendFlavour("image/jpg");flavours.appendFlavour("image/jpeg");
	 				flavours.appendFlavour("image/gif");
					flavours.appendFlavour("text/html"); //added for 2.0.0.3beta1 as image dnd for ff3.5 has changed
	 			}
	 			else
	 			flavours.appendFlavour("text/html"); 
	 			 			 			
	 			return flavours;
	 		},
	 		
	 		onDragOver: function (evt,flavour,session)
	 		{
	 		},
	 		
	 		
	 		//image DND doesn't work properly on Linux, so two separate OS specific routines
	 		onDrop: function (evt,dropdata,session)
	 		{  
				try{
				imgDNDObserver.logThis("image dropped");		
				if (isFF35)
				{ 
				alert("Image sidebar is disabled on Firefox 3.5 in this beta !") ; 
				return;
				}
				
				//logStringMessage("dropped");
					imgDNDObserver.logThis("dropped");		
				if (isWin){imgDNDObserver.winOnDrop(evt,dropdata,session); return }
	
	 		   	//Check if the dropped thing is an image:
				var dt=dropdata.data;
				if (dt==null) return;
				if (dt==""){alert(" No Data! ");return;} //Should ever?
				
				var imgtag=dt.match(/<img\s[^>]*>/gi);
				if  (imgtag == null ){return;}/*alert("Data doesn't contain any image!\n" + dt)*/
				//else
				 		   	
	 		  
	 			//if an image is already present, then that image becomes the target!	
	 			var evtTarget=evt.target;
	 			var tID=" "+evtTarget.getAttribute("id");
	 			//climb up to the box
	 			while(tID.search(/imgboard/) == -1 )
	 			{
	 			  evtTarget=evtTarget.parentNode;
	 			  tID=" "+evtTarget.getAttribute("id");
	 			
	 			} 			
	 			var topBox=evtTarget;  		   
	 			
	 			//parse the tag for attribs
				var tmpvar = null;
				var imgsrc = null;
				var imgstyle = null;
				var imgdomain =null;
				var imgw = null;
				var imgh = null;
				var bW=false; 
				var bH=false; 
				
				tmpvar=imgtag[0].match(/src[\s]*=[\s]*['"][^"']*/gi);
				if (tmpvar) imgsrc=tmpvar[0].replace( /src[\s]*=[\s]*['"]/gi,"");
					if(!imgsrc) return;		
				
				tmpvar=imgtag[0].match(/style[\s]*=[\s]*['"][^"']*/gi);
				if (tmpvar) 
					{imgstyle=tmpvar[0].replace( /style[\s]*=[\s]*['"]/gi,"");
					//see if style provides height/width
					if ( imgstyle.match(/width:[\s]*[\d]/gi) ) bW=true;
					if ( imgstyle.match(/width:[\s]*[\d]/gi) ) bH=true;
					}
				if (!imgw && !bW)
					{
					tmpvar=imgtag[0].match(/width[\s]*=[\s]*['"][^"']*/gi);
					if (tmpvar) imgw=tmpvar[0].replace( /width[\s]*=[\s]*['"]/gi,"");
					}
				if (!imgh && !bH)
					{
					tmpvar=imgtag[0].match(/height[\s]*=[\s]*['"][^"']*/gi);
					if (tmpvar) imgh=tmpvar[0].replace( /height[\s]*=[\s]*['"]/gi,"");
					}
				tmpvar = imgsrc.match(/\/\/[^\/]*/g);
				if (tmpvar) 
					{ 
						imgdomain= (tmpvar[0]).substring(2);
					}
				tmpvar=null;
				
				
				var elem=  document.createElementNS("http://www.w3.org/1999/xhtml","html:img"); //else an XUL image was created
				//(session.sourceNode).cloneNode(true);
	 			
	 			//needed
	 			if (!imgw && !bW )imgw="100"; elem.setAttribute("width",imgw);
	 			if (!imgh && !bH)imgh="100"; elem.setAttribute("height",imgh);
				if (imgstyle)elem.setAttribute("style",imgstyle);
				//if (imgdomain) elem.setAttribute("alt","Source - "+imgdomain); 	//Getting mangled with SU now, change!
					
	 			elem.setAttribute("src",imgsrc);
	 			//delete on doubleclick
	 			//elem.setAttribute("ondblclick","imgDNDObserver.deleteThis(event)"); //a gotcha! :-) 			
				topBox.appendChild(elem);		
				
	 		 }catch(ex) {alert("Error: " + ex.message); /* or Die silently? */ }
	 		},
	 		
	 /* Start  Adding-----------------wysuwyg remove-		
	onDragStart: function (evt,transferData,action){
	
		  
		  var evtTarget=evt.target;
	 	  //var tID=" "+evtTarget.nodeType+ evtTarget.nodeName; //getAttribute("nodeType");
		  var sr=evt.target.getAttribute("src");
		  //alert(sr);
		  var txt="<img src="+src+"/>";
	    transferData.data=new TransferData();
		transferData.data.addDataForFlavour("text/unicode",txt);
		  //window.alert(tID);
		  logThis(tID);
		
		  while(elme.id != this.statusbarPanel){
		    elme =elme.parentNode;
		  }
		  var txt=elme.getAttribute("id");
		  transferData.data=new TransferData();
		  transferData.data.addDataForFlavour(this.flavour,txt);
		  var status = document.getElementById(this.statusbarPanel);
		  var statusbar = document.getElementById(this.statbar);
		  var child = statusbar.firstChild;
		  var x = 0;
		  while (child) {
		    if (child != status) {
		      if (!child.id) {
		        var newId = "statusbarpanel-noID"+x;
		        while (document.getElementById(newId)) newId += "x"+x;
		        child.id = newId;
		        child.setAttribute("persist", new String("id" + (child.persist ? " "+child.persist : "")) );
		        x++;
		      }
		      if (child.childNodes.length == 0 && document.getAnonymousNodes(child).length == 0)
		        child.setAttribute("abnochildren", true);
		      child.addEventListener("dragenter", function(event) { nsDragAndDrop.dragEnter(event,Ext_statObserver); }, false);
		      child.addEventListener("dragover", function(event) { nsDragAndDrop.dragOver(event,Ext_statObserver); }, false);
		      child.addEventListener("dragdrop", function(event) { nsDragAndDrop.drop(event,Ext_statObserver); }, false);
		    }
		    child = child.nextSibling;
		  }
		
		  window.addEventListener("dragexit", function(event) { nsDragAndDrop.dragExit(event,Ext_statObserver); }, true);
		},
	---End Adding---------------------- */
	logThis : function (msg)
	{
		
	  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
	                                 .getService(Components.interfaces.nsIConsoleService);
	  consoleService.logStringMessage("Logged:"+ msg);
	
	},
	
	 		
	 		//Image DND for windows.
	 		winOnDrop: function (evt,dropdata,session)
	 		{
	 			var type=dropdata.flavour.contentType;
	 		   	if (type.search(/^image/) == -1) {alert("Data doesn't look like an image!");return;}
	 		   	
	 		   	//else
	 		  try{
	 			//if an image is already present, then that image becomes the target!	
	 			var evtTarget=evt.target;
	 			var tID=" "+evtTarget.getAttribute("id");
	 			//climb up to the box
	 			while(tID.search(/imgboard/) == -1 )
	 			{
	 			  evtTarget=evtTarget.parentNode;
	 			  tID=" "+evtTarget.getAttribute("id");
	 			
	 			}
	 			
	 			var topBox=evtTarget; 			
	 		   var elem=  document.createElementNS("http://www.w3.org/1999/xhtml","html:img"); //else an XUL image was created
				//elem.setAttribute("src",session.sourceNode.src);
	 			//var elem=(session.sourceNode).cloneNode(true);			
	 			
	 			topBox.appendChild(elem);
	 			//needed
	 			elem.setAttribute("width",session.sourceNode.width);
	 			elem.setAttribute("height",session.sourceNode.height);
	 			//fixes relative urls
	 			elem.setAttribute("src",session.sourceNode.src);
	 			//delete on doubleclick
	 			//elem.setAttribute("ondblclick","imgDNDObserver.deleteThis(event)"); //whoa, but a gotcha! :-) 			
	 			
	 		 }catch(ex) {alert("Error: " + ex.message); /* or Die silently? */ }
	 		},
	 		
	 		
	 		
	 		
	 		//remove an image on a specific event
	 		deleteThis: function (ev)
	 		{  		  
	 		   var img=ev.target;
	 		   var tID=" "+img.getAttribute("id");
	 		   if ((tID.search(/imgboard/) != -1 )) return;
	 		   //else
	 		   var board=img.parentNode;
	 		   board.removeChild(img);
	 		   ev.preventDefault();
	 		},
	 	
	 };
